=== debian/changelog ===
ceph (14.2.22-0ubuntu0.19.10.1~cloud2) bionic; urgency=medium

  * d/p/disable-log-slow-requests.patch: Remove logging every slow
    request details to monitors LP: #1909162).

 -- Chris MacNaughton <chris.macnaughton@ubuntu.com>  Tue, 22 Nov 2022 17:09:19 +0000

ceph (14.2.22-0ubuntu0.19.10.1~cloud1) bionic; urgency=medium

  * New upstream stable point release (LP: #1940959) including fix for:
    - CVE 2021-20288: Unauthorized global_id reuse in cephx.

 -- James Page <james.page@ubuntu.com>  Tue, 21 Sep 2021 16:08:52 +0100

ceph (14.2.18-0ubuntu0.19.10.1~cloud1) bionic; urgency=medium

  * d/*.install: restore ceph-*-tool binaries in packages after removal
    of ceph-test binary package (LP: #1917288).

 -- Dariusz Gadomski <dgadomski@ubuntu.com>  Mon, 24 May 2021 14:50:50 +0100

ceph (14.2.18-0ubuntu0.19.10.1~cloud0) bionic; urgency=medium

  * New upstream stable point release (LP: #1921353):
    - d/p/align-write-zeroes-declarations.patch: Drop, included in release.
    - d/p/bluefs-use-uint64_t-for-len.patch: Rebase.
  * Fold in backport-o-matic patches as parent distribution (Eoan) is EOL.

 -- James Page <james.page@ubuntu.com>  Fri, 26 Mar 2021 09:24:54 +0000

ceph (14.2.11-0ubuntu0.19.10.1~cloud4) bionic-train; urgency=medium

  * d/p/rules: Enable RelWithDebInfo (LP: #1894453).

 -- Corey Bryant <corey.bryant@canonical.com>  Mon, 26 Oct 2020 09:02:49 -0400

ceph (14.2.11-0ubuntu0.19.10.1~cloud2) bionic-train; urgency=medium

  * d/p/align-write-zeroes-declarations.patch: Fix failing i386 build
    caused by mismatched function declarations, updated based on
    upstream review comments (LP: #1891661).

 -- Corey Bryant <corey.bryant@canonical.com>  Mon, 17 Aug 2020 08:35:37 -0400

ceph (14.2.11-0ubuntu0.19.10.1~cloud1) bionic-train; urgency=medium

  * New upstream point release (LP: #1891077).
  * d/p/align-write-zeroes-declarations.patch: Fix failing i386 build
    caused by mismatched function declarations (LP: #1891661).

 -- Corey Bryant <corey.bryant@canonical.com>  Thu, 13 Aug 2020 09:44:38 -0400

ceph (14.2.10-0ubuntu0.19.10.1~cloud0) bionic-train; urgency=medium

  * New upstream point release (LP: #1891077):
    - d/p/bug1867386.patch: Drop, included in release.
    - d/rules: Disable Kafka endpoint support for RGW.
    - d/libcephfs-dev.install: Account for rename of ceph_statx.h to
      ceph_ll_client.h.

 -- Corey Bryant <corey.bryant@canonical.com>  Mon, 10 Aug 2020 16:38:32 -0400

ceph (14.2.9-0ubuntu0.19.10.1~cloud0) bionic-train; urgency=medium

  * New upstream release for the Ubuntu Cloud Archive.

 -- Openstack Ubuntu Testing Bot <openstack-testing-bot@ubuntu.com>  Tue, 26 May 2020 20:32:12 +0000

ceph (14.2.9-0ubuntu0.19.10.1) eoan; urgency=medium

  [ Tiago Pasqualini da Silva ]
  * d/p/bug1867386: Cherry pick change that adds new configuration
    option in RGW Beast frontend to allow tuning of maximum backlog
    of pending connections (LP: #1867386).

  [ James Page ]
  * New upstream point release (LP: #1878146) including fixes for:
    - CVE-2020-1759: Fixed nonce reuse in msgr V2 secure mode
    - CVE-2020-1760: Fixed XSS due to RGW GetObject header-splitting

 -- James Page <james.page@ubuntu.com>  Thu, 21 May 2020 08:52:43 +0100

ceph (14.2.8-0ubuntu0.19.10.1) eoan; urgency=medium

  * New upstream point release (LP: #1861789):
    - d/p/issue{37490,40114,40781}.patch: Drop, included in point release.
    - d/control: Add libcap-ng-dev to BD's.
    - d/control: Add libnl-genl-3-dev to BD's.
    - d/p/bluefs-use-uint64_t-for-len.patch: Fix type mismatch issue on
      32bit architectures.
    - d/p/CVE-2020-1700.patch: Drop, included in release.
    - d/p/32bit-fixes.patch: Misc 32 bit architecture fixes for
      mismatched types.
  * d/control: Add missing Depends on python3-{distutils,routes} to
    ceph-mgr-dashboard package (LP: #1858304).

 -- James Page <james.page@ubuntu.com>  Wed, 25 Mar 2020 15:59:57 +0000
